// Compiled by ClojureScript 1.10.520 {}
goog.provide('weathergen.ipc');
goog.require('cljs.core');
goog.require('weathergen.encoding');
weathergen.ipc.electron = require("electron");
weathergen.ipc.channel = "weathergen-ipc";
if((typeof weathergen !== 'undefined') && (typeof weathergen.ipc !== 'undefined') && (typeof weathergen.ipc.on_message !== 'undefined')){
} else {
weathergen.ipc.on_message = (function (){var method_table__4613__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var prefer_table__4614__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var method_cache__4615__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var cached_hierarchy__4616__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var hierarchy__4617__auto__ = cljs.core.get.call(null,cljs.core.PersistentArrayMap.EMPTY,new cljs.core.Keyword(null,"hierarchy","hierarchy",-1053470341),cljs.core.get_global_hierarchy.call(null));
return (new cljs.core.MultiFn(cljs.core.symbol.call(null,"weathergen.ipc","on-message"),((function (method_table__4613__auto__,prefer_table__4614__auto__,method_cache__4615__auto__,cached_hierarchy__4616__auto__,hierarchy__4617__auto__){
return (function() { 
var G__40324__delegate = function (type,event,args){
return type;
};
var G__40324 = function (type,event,var_args){
var args = null;
if (arguments.length > 2) {
var G__40325__i = 0, G__40325__a = new Array(arguments.length -  2);
while (G__40325__i < G__40325__a.length) {G__40325__a[G__40325__i] = arguments[G__40325__i + 2]; ++G__40325__i;}
  args = new cljs.core.IndexedSeq(G__40325__a,0,null);
} 
return G__40324__delegate.call(this,type,event,args);};
G__40324.cljs$lang$maxFixedArity = 2;
G__40324.cljs$lang$applyTo = (function (arglist__40326){
var type = cljs.core.first(arglist__40326);
arglist__40326 = cljs.core.next(arglist__40326);
var event = cljs.core.first(arglist__40326);
var args = cljs.core.rest(arglist__40326);
return G__40324__delegate(type,event,args);
});
G__40324.cljs$core$IFn$_invoke$arity$variadic = G__40324__delegate;
return G__40324;
})()
;})(method_table__4613__auto__,prefer_table__4614__auto__,method_cache__4615__auto__,cached_hierarchy__4616__auto__,hierarchy__4617__auto__))
,new cljs.core.Keyword(null,"default","default",-1987822328),hierarchy__4617__auto__,method_table__4613__auto__,prefer_table__4614__auto__,method_cache__4615__auto__,cached_hierarchy__4616__auto__));
})();
}
/**
 * Sends a message from a renderer process to the main process.
 */
weathergen.ipc.send_to_main = (function weathergen$ipc$send_to_main(var_args){
var args__4736__auto__ = [];
var len__4730__auto___40330 = arguments.length;
var i__4731__auto___40331 = (0);
while(true){
if((i__4731__auto___40331 < len__4730__auto___40330)){
args__4736__auto__.push((arguments[i__4731__auto___40331]));

var G__40332 = (i__4731__auto___40331 + (1));
i__4731__auto___40331 = G__40332;
continue;
} else {
}
break;
}

var argseq__4737__auto__ = ((((1) < args__4736__auto__.length))?(new cljs.core.IndexedSeq(args__4736__auto__.slice((1)),(0),null)):null);
return weathergen.ipc.send_to_main.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__4737__auto__);
});

weathergen.ipc.send_to_main.cljs$core$IFn$_invoke$arity$variadic = (function (type,args){
return cljs.core.apply.call(null,(function (){var G__40329 = weathergen.ipc.electron.ipcRenderer;
return G__40329;
})().send,weathergen.ipc.channel,type,cljs.core.map.call(null,weathergen.encoding.encode,args));
});

weathergen.ipc.send_to_main.cljs$lang$maxFixedArity = (1);

/** @this {Function} */
weathergen.ipc.send_to_main.cljs$lang$applyTo = (function (seq40327){
var G__40328 = cljs.core.first.call(null,seq40327);
var seq40327__$1 = cljs.core.next.call(null,seq40327);
var self__4717__auto__ = this;
return self__4717__auto__.cljs$core$IFn$_invoke$arity$variadic(G__40328,seq40327__$1);
});

/**
 * Sends a message from the main process to a renderer process.
 */
weathergen.ipc.send_to_renderer = (function weathergen$ipc$send_to_renderer(var_args){
var args__4736__auto__ = [];
var len__4730__auto___40336 = arguments.length;
var i__4731__auto___40337 = (0);
while(true){
if((i__4731__auto___40337 < len__4730__auto___40336)){
args__4736__auto__.push((arguments[i__4731__auto___40337]));

var G__40338 = (i__4731__auto___40337 + (1));
i__4731__auto___40337 = G__40338;
continue;
} else {
}
break;
}

var argseq__4737__auto__ = ((((2) < args__4736__auto__.length))?(new cljs.core.IndexedSeq(args__4736__auto__.slice((2)),(0),null)):null);
return weathergen.ipc.send_to_renderer.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),(arguments[(1)]),argseq__4737__auto__);
});

weathergen.ipc.send_to_renderer.cljs$core$IFn$_invoke$arity$variadic = (function (window,type,args){
var wc = window.webContents;
var send = wc.send;
return send.apply(wc,cljs.core.clj__GT_js.call(null,cljs.core.into.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [weathergen.ipc.channel,type], null),cljs.core.map.call(null,weathergen.encoding.encode,args))));
});

weathergen.ipc.send_to_renderer.cljs$lang$maxFixedArity = (2);

/** @this {Function} */
weathergen.ipc.send_to_renderer.cljs$lang$applyTo = (function (seq40333){
var G__40334 = cljs.core.first.call(null,seq40333);
var seq40333__$1 = cljs.core.next.call(null,seq40333);
var G__40335 = cljs.core.first.call(null,seq40333__$1);
var seq40333__$2 = cljs.core.next.call(null,seq40333__$1);
var self__4717__auto__ = this;
return self__4717__auto__.cljs$core$IFn$_invoke$arity$variadic(G__40334,G__40335,seq40333__$2);
});

weathergen.ipc.ipc = ((cljs.core._EQ_.call(null,undefined,weathergen.ipc.electron.ipcMain))?weathergen.ipc.electron.ipcRenderer:weathergen.ipc.electron.ipcMain);
weathergen.ipc.ipc.on(weathergen.ipc.channel,(function() { 
var G__40343__delegate = function (event,p__40339){
var vec__40340 = p__40339;
var seq__40341 = cljs.core.seq.call(null,vec__40340);
var first__40342 = cljs.core.first.call(null,seq__40341);
var seq__40341__$1 = cljs.core.next.call(null,seq__40341);
var type = first__40342;
var args = seq__40341__$1;
return cljs.core.apply.call(null,weathergen.ipc.on_message,type,event,cljs.core.map.call(null,weathergen.encoding.decode,args));
};
var G__40343 = function (event,var_args){
var p__40339 = null;
if (arguments.length > 1) {
var G__40344__i = 0, G__40344__a = new Array(arguments.length -  1);
while (G__40344__i < G__40344__a.length) {G__40344__a[G__40344__i] = arguments[G__40344__i + 1]; ++G__40344__i;}
  p__40339 = new cljs.core.IndexedSeq(G__40344__a,0,null);
} 
return G__40343__delegate.call(this,event,p__40339);};
G__40343.cljs$lang$maxFixedArity = 1;
G__40343.cljs$lang$applyTo = (function (arglist__40345){
var event = cljs.core.first(arglist__40345);
var p__40339 = cljs.core.rest(arglist__40345);
return G__40343__delegate(event,p__40339);
});
G__40343.cljs$core$IFn$_invoke$arity$variadic = G__40343__delegate;
return G__40343;
})()
);
